#ifndef _I386_MAGIC_H
#define _I386_MAGIC_H

#define I386_BLOCK_SIZE 4096	// 4KB
#define I386_POINTER_SIZE 4	// of analyzed system
#define I386_INTEGER_SIZE 4	// of analyzed system


// Virtual Page Table (or PaGe Directory (PGD))
#define I386_VPT_MAGIC_ADDR 0x00000000	// where to start looking for VPT 
//Used to be 0x00300000, but windows seems to store this address
//on lower addresses

#define I386_VPT_MAGIC_BS 4096	// size of block with VPT

#define I386_VPT_MAGIC_COUNT 500000	// how many page to check, when looking for VPT XXX 5000
#define I386_VPT_MAGIC_ZEROES 3072	// how many zeroes should be at the beginning of VPT (PGD)
#define I386_VPT_MAGIC_ZEROES_ERR 40	// how many non-zero values can be inside
// "zero" area. This is only heuristic, see documentation for more info.
#define I386_VPT_MAGIC_ENTRIES_CHECK	5	//how many entries to check
#define I386_VPT_MAGIC_ENTRIES_ERR 1 //100	// how many different values can be
// in used area of PGD (only some bits are checked)

#endif
