/// Global defines and includes.
/**
 * @file
 */

#ifndef _GLOBALS_H
#define _GLOBALS_H

#define fversion "0.8.0" //Change on release

// This is needed for opening files bigger than 2GB
#define _FILE_OFFSET_BITS 64

/*
 * System libraries 
 */

#include <getopt.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include <sys/timeb.h>
#include <errno.h>
#include <libgen.h>

#include <math.h> //for round makro
#include "debug.h" // for dbgprint

#define round(x) ((x)>=0?(int)((x)+0.5):(int)((x)-0.5)) //
#define min(x,y) (x<y?x:y) //
#define max(x,y) (x>y?x:y) //

#define _GNU_SOURCE		// ;)
#define FORIANA_CACHE_SIZE 14	//how many lines (variables) are stored in "cache" files
#define LINE_SIZE 80		//size of terminal

#include "structs.h" 		//structure definitions
#include "arch/allarch.h"	//needed for global variables

/*
 * Forward declarations:
 */

int list_head_size(u_int64_t listhead);
int search_init(char *inputfile2,/*FILE *f2,*/const char *marker2,u_int64_t start_addr);
u_int64_t search_next();
int search_exit();


/*
 * Global variables
 */

extern struct my_image image1;

//char helpstatusfile[20]="foriana.cache";
extern char *statusfile2,*statusfile;
extern FILE *fs;	//cache file

extern char *inputfile;	//filename
extern int inputfd,statusfd;	//input & status output 
//extern FILE *f;	//separate descriptor for searching in file

extern struct stat sbuffer;

extern char *errormsg;

extern char MAGIC_MODULE[MD_NAME_LEN]; // user can specify magic constants
extern char MAGIC_PROCESS[TS_COMM_LEN]; //-||-
extern char MAGIC_USER_PROCESS[TS_COMM_LEN]; //-||-


extern int status;
//extern unsigned long pointer;

extern int do_files_det,do_files_list,do_arreas_list,ddebug; //global states of parsed options
extern int do_create_proc_pattern; //global states of parsed options
extern int do_create_module_pattern; //global states of parsed options

#endif
